/*
 * cp40pgplot.c --
 *
 *	Provides interface of CP40 with PGPLOT.
 *
 * Copyright (c) 2000, Eric THIEBAUT.
 *	See the file "LICENSE" for information on usage and redistribution
 *	of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * History:
 *	$Id$
 *	$Log$
 *-----------------------------------------------------------------------------
 */

#include "cp40pgplot.h"

/*---------------------------------------------------------------------------*/
/* CACHE MANAGEMENT */
static char small_cache[16384]; /* Small buffer cache for i/o or conversion,
				   if we need more we will alloc and free
				   a bigger cache. */
static void *get_cache(unsigned size);
static void  release_cache(void *cache);
static void *get_cache(unsigned size)
{
  void *cache;
  if (size <= sizeof small_cache) return small_cache;
  if ((cache= gpl_alloc(size)) != NULL) return cache;
  gpl_error("insufficient memory for %u bytes cache", size);
  return NULL;
}
static void  release_cache(void *cache)
{
  if (cache && cache!=small_cache) gpl_free(cache);
}

/*---------------------------------------------------------------------------*/

paint(TYPE *buf, int pitch, int width, int height, TYPE min, TYPE max,
      int imax, int imin, int inan, int iinfneg, int iinfpos)
{
}
