/*
 * cp40util.c --
 *
 *	Utility functions for the CP40 library.
 *
 * Copyright (c) 1995-2003 Eric THIEBAUT.
 *	See the file "LICENSE" for information on usage and redistribution
 *	of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * History:
 *	$Id: cp40util.c,v 1.1 2003/06/25 14:07:23 eric Exp $
 *	$Log: cp40util.c,v $
 *	Revision 1.1  2003/06/25 14:07:23  eric
 *	Initial revision
 *
 *-----------------------------------------------------------------------------
 */

#include "gpl_base.h"
#include "cp40.h"

/*---------------------------------------------------------------------------*/
/* MEMORY ALLOCATION */

void *cp40_alloc(unsigned int size, const char *what)
{
  void *ptr;
  if (! (ptr= gpl_alloc(size))) {
    if (what && strlen(what)<30) {
      gpl_error("insufficient memory for %s", what);
    } else {
      gpl_error("insufficient memory %u bytes", size);
    }
    return NULL;
  }
  return ptr;
}

void *cp40_alloc_clear(unsigned int size, const char *what)
{
  void *ptr;
  if ((ptr= cp40_alloc(size, what))) {
    memset(ptr, 0, size);
  }
  return ptr;
}

/*---------------------------------------------------------------------------*/
