#include "/home/eric/work/yeti-5.3.3/yeti/yeti_cp40.i"
func XConfig(this, correction=, scale=, angle=, pixel=, config=, reset=)
{
  if (reset) {
    cp40_cancel, this, "*";
    cp40_rewind, this;
  }
  if (! is_void(config)) cp40_copy, config, this;
  if (! is_void(correction)) cp40_set, this, "correction", correction;
  if (! is_void(scale)) cp40_set, this, "scale", scale;
  if (! is_void(angle)) cp40_set, this, "angle", angle;
  if (! is_void(pixel)) cp40_set, this, "pixel", pixel;
  return this;
}
func XTasks(task)
{
  if (structof(task) == string && ! dimsof(task)(1) &&
      strpart(task, 0:0) == "*") {
    prefix = strpart(task, 1:-1);
    if (prefix == "it" || prefix == "ac") {
      return swrite(format="%s%d", prefix, indgen(0:3));
    } else if (prefix == "ic") {
      return ["ic01", "ic02", "ic03", "ic12", "ic13", "ic23"];
    }
  }
  return task;
}
func XToken(prefix, chn1, chn2)
{
  if (is_void(chn1)) return prefix;
  if (! is_void(chn2))  return swrite(format="%s%d%d", prefix, chn1, chn2);
  if (prefix == "ic") return swrite(format="ic%02d", chn1);
  return swrite(format="%s%d", prefix, chn1);
}

func XRun(this, .., correction=, scale=, angle=, pixel=, config=, reset=)
{
  if (reset) {
    cp40_cancel, this, "*";
    cp40_rewind, this;
  }
  if (! is_void(config)) cp40_copy, config, this;
  if (! is_void(correction)) cp40_set, this, "correction", correction;
  if (! is_void(scale)) cp40_set, this, "scale", scale;
  if (! is_void(angle)) cp40_set, this, "angle", angle;
  if (! is_void(pixel)) cp40_set, this, "pixel", pixel;
  while (more_args()) {
    task = XTasks(next_arg());
    if (! is_void(task)) cp40_schedule, this, task;
  }
  return cp40_run(this);
}
func XPlot(this, .., win=, style=)
{
  if (is_void(style)) style="nobox.gs";
  if (is_void(win)) {
    win = current_window();
    if (win < 0) win = 0;
  }
  while (more_args()) {
    task = XTasks(next_arg());
    if (is_void(task)) continue;
    for (i=1 ; i<=numberof(task) ; ++i) {
      window, win++, style=style;
      fma;
      cp40_pli, this, task(i);
      pause, 1;
    }
  }
}

#if 0
p = array(pointer, 4, 3);
this = cp40_open("/work/eric/data/ESO-2000-07/Grid_01.cp40",
                 config="/work/eric/data/ESO-2000-07/distortion_Grid_01.cfg");
XRun(this, "it*", correction="simple", reset=1);
for (i=1;i<=4;++i) p(i,1) = &cp40_task_data(this,XToken("it",i-1));
XPlot, this, win=0, "it*";


XRun(this, "it*", correction="weighted", reset=1);
for (i=1;i<=4;++i) p(i,2) = &cp40_task_data(this,XToken("it",i-1));
XPlot, this, win=4, "it*";


w0 = 1.0 + random(384, 288);
w1 = 1.0 + random(384, 288);
w2 = 1.0 + random(384, 288);
w3 = 1.0 + random(384, 288);
cp40_reweight, this, w0, w1, w2, w3, reset=1;
XRun(this, "it*", correction="weighted", reset=1);
for (i=1;i<=4;++i) p(i,3) = &cp40_task_data(this,XToken("it",i-1));
XPlot, this, win=8, "it*";
#endif

#if 0

cp40_set,id,"correction","simple";
cp40_schedule,id,"it0","it1","it2","it3";

cp40_cancel,id,"*"
 cp40_set,id,"correction","none"
cp40_schedule,id,"it0","it1","it2","it3";
cp40_run(cp40_rewind(id))
for (i=0;i<4;++i) {window,i,style="nobox.gs";fma;pli,cp40_task_data(id,swrite(format="id%d",i));}

dbexit
for (i=0;i<4;++i) {window,i,style="nobox.gs";fma;pli,cp40_task_data(id,swrite(format="it%d",i));}
cp40_cancel,id,"*"
cp40_cancel,id,"*"; cp40_set,id,"correction","simple";cp40_schedule,id,"it0","it1","it2","it3";
cp40_run(cp40_rewind(id));
for (i=0;i<4;++i) {window,i,style="nobox.gs";fma;pli,cp40_task_data(id,swrite(format="it%d",i));}
cp40_cancel,id,"*"; cp40_set,id,"correction","random";cp40_schedule,id,"it0","it1","it2","it3";
cp40_run(cp40_rewind(id));
cp40_cancel,id,"*"; cp40_set,id,"correction","random";cp40_schedule,id,"it0","it1","it2","it3";
cp40_cancel,id,"*"; cp40_set,id,"correction","weighted";cp40_schedule,id,"it0","it1","it2","it3";
cp40_run(cp40_rewind(id));
cp40_cancel,id,"*"; cp40_set,id,"correction","random";cp40_schedule,id,"ac0","ac1","ac2","ac3";
cp40_run(cp40_rewind(id));
for (i=0;i<4;++i) {window,i,style="nobox.gs";fma;pli,cp40_task_data(id,swrite(format="ac%d",i));}
info,cp40_task_data(id,swrite(format="ac%d",3))
cp40_cancel,id,"*"; cp40_set,id,"correction","simple";cp40_schedule,id,"ac0","ac1","ac2","ac3";
cp40_run(cp40_rewind(id));
#endif
