/*
 * gpl_num_op.c --
 *
 *	Implements some utility routines and operator routines to mock
 *	optimizer.
 *
 * Copyright (c) 1999 Eric THIEBAUT.
 *	See the file "LICENSE" for information on usage and redistribution
 *	of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * History:
 *	$Id$
 *	$Log$
 */

#include <math.h>
#include "gpl_num.h"


int gpl_num_almost_equal(double a, double b, double tol)
{
  return 2.0*fabs(a-b) <= tol*(fabs(a)+fabs(b));
}

#undef FUNC
#define FUNC(TYPE, NAME, OP) TYPE NAME(TYPE a, TYPE b) { return a OP b; }
FUNC(float,  gpl_num_add_f, +)
FUNC(double, gpl_num_add_d, +)
FUNC(float,  gpl_num_sub_f, -)
FUNC(double, gpl_num_sub_d, -)
FUNC(float,  gpl_num_mul_f, *)
FUNC(double, gpl_num_mul_d, *)
FUNC(float,  gpl_num_div_f, /)
FUNC(double, gpl_num_div_d, /)

#undef FUNC
#define FUNC(TYPE, NAME, OP) int NAME(TYPE a, TYPE b) { return a OP b; }
FUNC(float,  gpl_num_eq_f, ==)
FUNC(double, gpl_num_eq_d, ==)
FUNC(float,  gpl_num_ne_f, !=)
FUNC(double, gpl_num_ne_d, !=)
FUNC(float,  gpl_num_ge_f, >=)
FUNC(double, gpl_num_ge_d, >=)
FUNC(float,  gpl_num_gt_f, >)
FUNC(double, gpl_num_gt_d, >)
FUNC(float,  gpl_num_le_f, <=)
FUNC(double, gpl_num_le_d, <=)
FUNC(float,  gpl_num_lt_f, <)
FUNC(double, gpl_num_lt_d, <)

#undef FUNC
#define FUNC(TYPE, NAME) int NAME(TYPE a, TYPE b) { return a>b?1:(a<b?-1:0); }
FUNC(float,  gpl_num_cmp_f)
FUNC(double, gpl_num_cmp_d)

#undef FUNC
#define FUNC(TYPE, NAME) void NAME(TYPE *addr, TYPE value) { *addr= value; }
FUNC(float,  gpl_num_store_f)
FUNC(double, gpl_num_store_d)
