(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 3.0,
MathReader 3.0, or any compatible application. The data for the notebook 
starts with the line of stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    143060,       2599]*)
(*NotebookOutlinePosition[    143698,       2622]*)
(*  CellTagsIndexPosition[    143654,       2618]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[TextData["Parabola \[Rule]2D gaussian parameters"], "Title"],

Cell["Equation of 2D parabola:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(c1 + c2\ x + c3\ y + c4\ x\^2 + c5\ x\ y + c6\ y\^2\)], "Input"],

Cell[BoxData[
    \(c1 + c2\ x + c4\ x\^2 + c3\ y + c5\ x\ y + c6\ y\^2\)], "Output"]
}, Closed]],

Cell["\<\

Equation of logarithm of 2D Gaussian:\
\>", "Text"],

Cell[BoxData[
    \(q0\  - \ q1\ u1\^2 - q2\ u2\^2\)], "Input"],

Cell["where:", "Text"],

Cell[BoxData[
    \({u1 \[Rule] Cos[a] \((x - x0)\) + Sin[a] \((y - y0)\), 
      u2 \[Rule] Cos[a] \((y - y0)\) - Sin[a] \((x - x0)\)}\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(q0\  - \ q1\ u1\^2 - q2\ u2\^2 /. {
        u1 \[Rule] Cos[a] \((x - x0)\) + Sin[a] \((y - y0)\), 
        u2 \[Rule] Cos[a] \((y - y0)\) - Sin[a] \((x - x0)\)}\)], "Input"],

Cell[BoxData[
    \(q0 - q2\ \((\((y - y0)\)\ Cos[a] - \((x - x0)\)\ Sin[a])\)\^2 - 
      q1\ \((\((x - x0)\)\ Cos[a] + \((y - y0)\)\ Sin[a])\)\^2\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(mg[x_, y_] := 
      q0 - q2\ \((\((y - y0)\)\ Cos[a] - \((x - x0)\)\ Sin[a])\)\^2 - 
        q1\ \((\((x - x0)\)\ Cos[a] + \((y - y0)\)\ Sin[a])\)\^2\)], "Input"],

Cell[BoxData[
    \(mp[x_, y_] := c1 + c2\ x + c3\ y + c4\ x\^2 + c5\ x\ y + c6\ y\^2\)], 
  "Input"],

Cell["\<\
Identifiaction of the parabola coefficients (there is certainly a \
better way to do that!):\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \({mg[0, 0], \ Coefficient[mg[x, 0], x], \ Coefficient[mg[0, y], y], \ 
      Coefficient[mg[x, 0], x\^2], \ Coefficient[mg[x, y], x\ y], \ 
      Coefficient[mg[0, y], y\^2]}\)], "Input"],

Cell[BoxData[
    \({q0 - q2\ \((\(-y0\)\ Cos[a] + x0\ Sin[a])\)\^2 - 
        q1\ \((\(-x0\)\ Cos[a] - y0\ Sin[a])\)\^2, 
      2\ q1\ x0\ Cos[a]\^2 + 2\ q1\ y0\ Cos[a]\ Sin[a] - 
        2\ q2\ y0\ Cos[a]\ Sin[a] + 2\ q2\ x0\ Sin[a]\^2, 
      2\ q2\ y0\ Cos[a]\^2 + 2\ q1\ x0\ Cos[a]\ Sin[a] - 
        2\ q2\ x0\ Cos[a]\ Sin[a] + 2\ q1\ y0\ Sin[a]\^2, 
      \(-q1\)\ Cos[a]\^2 - q2\ Sin[a]\^2, 
      \(-2\)\ q1\ Cos[a]\ Sin[a] + 2\ q2\ Cos[a]\ Sin[a], 
      \(-q2\)\ Cos[a]\^2 - q1\ Sin[a]\^2}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Solve[{
          q0 - q2\ \((\(-y0\)\ Cos[a] + x0\ Sin[a])\)\^2 - 
            q1\ \((\(-x0\)\ Cos[a] - y0\ Sin[a])\)\^2, 
          2\ q1\ x0\ Cos[a]\^2 + 2\ q1\ y0\ Cos[a]\ Sin[a] - 
            2\ q2\ y0\ Cos[a]\ Sin[a] + 2\ q2\ x0\ Sin[a]\^2, 
          2\ q2\ y0\ Cos[a]\^2 + 2\ q1\ x0\ Cos[a]\ Sin[a] - 
            2\ q2\ x0\ Cos[a]\ Sin[a] + 2\ q1\ y0\ Sin[a]\^2, 
          \(-q1\)\ Cos[a]\^2 - q2\ Sin[a]\^2, 
          \(-2\)\ q1\ Cos[a]\ Sin[a] + 2\ q2\ Cos[a]\ Sin[a], 
          \(-q2\)\ Cos[a]\^2 - q1\ Sin[a]\^2} == {c1, c2, c3, c4, c5, c6}, {
        q0, q1, q2, x0, y0, a}]\n\)\)], "Input"],

Cell[BoxData[
    \(Solve::"ifun" \( : \ \) 
      "Inverse functions are being used by \!\(Solve\), so some solutions may \
not be found."\)], "Message"],

Cell[BoxData[
    \({{q0 \[Rule] 
          \(\(-c3\^2\)\ c4 + c2\ c3\ c5 - c1\ c5\^2 - c2\^2\ c6 + 
              4\ c1\ c4\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        q1 \[Rule] 
          1\/2\ \((
              \(-2\)\ c6 - c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), q2 \[Rule] 
          1\/2\ \((
              \(-2\)\ c4 + c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), 
        x0 \[Rule] \(c3\ c5 - 2\ c2\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          \(-ArcCos[
              \(-\(1\/\@2\((
                  \[Sqrt]\((
                      c4\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c5\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        \(2\ c4\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + 
                            c6\^2\) + 
                        c6\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c4\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)\)\)]
              \)}, {q0 \[Rule] 
          \(\(-c3\^2\)\ c4 + c2\ c3\ c5 - c1\ c5\^2 - c2\^2\ c6 + 
              4\ c1\ c4\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        q1 \[Rule] 
          1\/2\ \((
              \(-2\)\ c6 - c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), q2 \[Rule] 
          1\/2\ \((
              \(-2\)\ c4 + c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), x0 \[Rule] 
          \(c3\ c5 - 2\ c2\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          ArcCos[\(-
              \(1\/\@2\((
                \[Sqrt]\((
                    c4\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c5\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                      \(2\ c4\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c6\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c4\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                      c6\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))
                \)\)\)]}, {
        q0 \[Rule] 
          \(\(-c3\^2\)\ c4 + c2\ c3\ c5 - c1\ c5\^2 - c2\^2\ c6 + 
              4\ c1\ c4\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        q1 \[Rule] 
          1\/2\ \((
              \(-2\)\ c6 - c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), q2 \[Rule] 
          1\/2\ \((
              \(-2\)\ c4 + c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), x0 \[Rule] 
          \(c3\ c5 - 2\ c2\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          \(-ArcCos[
              1\/\@2\((
                \[Sqrt]\((
                    c4\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c5\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                      \(2\ c4\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c6\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c4\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                      c6\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)]\)}, {
        q0 \[Rule] 
          \(\(-c3\^2\)\ c4 + c2\ c3\ c5 - c1\ c5\^2 - c2\^2\ c6 + 
              4\ c1\ c4\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        q1 \[Rule] 
          1\/2\ \((
              \(-2\)\ c6 - c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), q2 \[Rule] 
          1\/2\ \((
              \(-2\)\ c4 + c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 + 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), x0 \[Rule] 
          \(c3\ c5 - 2\ c2\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          ArcCos[1\/\@2\((
              \[Sqrt]\((
                  c4\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                    c5\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                    \(2\ c4\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                    c6\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                    c4\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                    c6\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)]}, {
        q0 \[Rule] 
          \(\(-c3\^2\)\ c4 + c2\ c3\ c5 - c1\ c5\^2 - c2\^2\ c6 + 
              4\ c1\ c4\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        q1 \[Rule] 
          1\/2\ \((
              \(-2\)\ c6 - c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), q2 \[Rule] 
          1\/2\ \((
              \(-2\)\ c4 + c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), x0 \[Rule] 
          \(c3\ c5 - 2\ c2\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          \(-ArcCos[
              \(-\(1\/\@2\((
                  \[Sqrt]\((
                      c4\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c5\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        \(2\ c4\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + 
                            c6\^2\) + 
                        c6\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                        c4\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)\)\)]
              \)}, {q0 \[Rule] 
          \(\(-c3\^2\)\ c4 + c2\ c3\ c5 - c1\ c5\^2 - c2\^2\ c6 + 
              4\ c1\ c4\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        q1 \[Rule] 
          1\/2\ \((
              \(-2\)\ c6 - c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), q2 \[Rule] 
          1\/2\ \((
              \(-2\)\ c4 + c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), x0 \[Rule] 
          \(c3\ c5 - 2\ c2\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          ArcCos[\(-
              \(1\/\@2\((
                \[Sqrt]\((
                    c4\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c5\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                      \(2\ c4\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c6\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                      c4\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c6\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))
                \)\)\)]}, {
        q0 \[Rule] 
          \(\(-c3\^2\)\ c4 + c2\ c3\ c5 - c1\ c5\^2 - c2\^2\ c6 + 
              4\ c1\ c4\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        q1 \[Rule] 
          1\/2\ \((
              \(-2\)\ c6 - c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), q2 \[Rule] 
          1\/2\ \((
              \(-2\)\ c4 + c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), x0 \[Rule] 
          \(c3\ c5 - 2\ c2\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          \(-ArcCos[
              1\/\@2\((
                \[Sqrt]\((
                    c4\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c5\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                      \(2\ c4\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c6\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                      c4\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                      c6\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)]\)}, {
        q0 \[Rule] 
          \(\(-c3\^2\)\ c4 + c2\ c3\ c5 - c1\ c5\^2 - c2\^2\ c6 + 
              4\ c1\ c4\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        q1 \[Rule] 
          1\/2\ \((
              \(-2\)\ c6 - c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), q2 \[Rule] 
          1\/2\ \((
              \(-2\)\ c4 + c4\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(c4\ c5\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(3\ c4\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                \(c5\^2\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(3\ c4\ c6\^2\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^3\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c4\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \(2\ c4\ c6\)\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                c6\^2\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                \((c4\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c4\^2\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c5\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\^3\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((6\ c4\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((2\ c5\^2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((4\ c4\ c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) + 
                \((c6\^4\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^2)\) - 
                \((c4\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((c4\ c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((3\ c4\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c5\^2\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((3\ c4\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) + 
                \((c6\^3\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ 
                      \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\)\^\(3/2\))\) - 
                \((2\ c4\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    c5\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) + \((
                    4\ c4\ c6\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \) - \((
                    2\ c6\^2\ \((
                      c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2 - 
                        c4\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                        c6\ \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)/
                  \((\((c4 - c6)\)\ \((c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2)\))
                    \))\), x0 \[Rule] 
          \(c3\ c5 - 2\ c2\ c6\)\/\(\(-c5\^2\) + 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          ArcCos[1\/\@2\((
              \[Sqrt]\((
                  c4\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                    c5\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                    \(2\ c4\ c6\)\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                    c6\^2\/\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) - 
                    c4\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\) + 
                    c6\/\@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\))\))\)]}}\)], 
  "Output"]
}, Closed]],

Cell[BoxData[
    \({{q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
        q1 \[Rule] 1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          \(-ArcCos[
              \(-\(\@\(1 + \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2
                      \)\)]\)}, {
        q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
        q1 \[Rule] 1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          ArcCos[\(-
              \(\@\(1 + \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2
                    \)\)]}, {
        q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
        q1 \[Rule] 1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          \(-ArcCos[
              \@\(1 + \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2]
              \)}, {q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
        q1 \[Rule] 1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          ArcCos[\@\(1 + 
                  \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2]}, {
        q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
        q1 \[Rule] 1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          \(-ArcCos[
              \(-\(\@\(1 + 
                        \(\(-c4\) + c6
                            \)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2\)\)]
              \)}, {q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
        q1 \[Rule] 1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          ArcCos[\(-
              \(\@\(1 + 
                      \(\(-c4\) + c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2
                    \)\)]}, {
        q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
        q1 \[Rule] 1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          \(-ArcCos[
              \@\(1 + \(\(-c4\) + c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2]
              \)}, {q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
        q1 \[Rule] 1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
        a \[Rule] 
          ArcCos[\@\(1 + 
                  \(\(-c4\) + c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2]}}
      \)], "Input"],

Cell[TextData[
"That's 8 different solutions! Let us choose the ones for which \
q1\[LessEqual]q2 (i.e. index 1 is for major axis) and for which Sin[a]\
\[GreaterEqual]0 (due to the symmetry of the Gaussian):"], "Text"],

Cell[BoxData[
    \(sol4
       := {{q0 \[Rule] 
            \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
                c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
          q1 \[Rule] 
            1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          q2 \[Rule] 
            1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
          y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
          a \[Rule] 
            \(-ArcCos[
                \(-\(\@\(1 + 
                          \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2
                        \)\)]\)}, {
          q0 \[Rule] 
            \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
                c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
          q1 \[Rule] 
            1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          q2 \[Rule] 
            1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
          y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
          a \[Rule] 
            ArcCos[\(-
                \(\@\(1 + \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2
                      \)\)]}, {
          q0 \[Rule] 
            \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
                c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
          q1 \[Rule] 
            1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          q2 \[Rule] 
            1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
          y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
          a \[Rule] 
            \(-ArcCos[
                \@\(1 + \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2]
                \)}, {q0 \[Rule] 
            \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
                c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
          q1 \[Rule] 
            1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          q2 \[Rule] 
            1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
          y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
          a \[Rule] 
            ArcCos[\@\(1 + 
                    \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2]}}\)], 
  "Input"],

Cell[TextData[{
  "Some simplifications (just to check that only the angle ",
  StyleBox["a", "InlineFormula"],
  " is different, and that makes 4 solutions: a, -a, \[Pi]-a and ):"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(sol4
       /. {c5\^2 - 4\ c4\ c6 \[Rule] \[CapitalDelta], 
        \@\(c5\^2 + \((c4 - c6)\)\^2\) \[Rule] s, 
        \@\(1 + \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\) \[Rule] 
          \@\(1 + \(c4 - c6\)\/s\)}\)], "Input"],

Cell[BoxData[
    \({{q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \[CapitalDelta]\)\/\[CapitalDelta], 
        q1 \[Rule] 1\/2\ \((\(-c4\) - c6 - s)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) - c6 + s)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\[CapitalDelta], 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\[CapitalDelta], 
        a \[Rule] \(-ArcCos[\(-\(\@\(1 + \(c4 - c6\)\/s\)\/\@2\)\)]\)}, {
        q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \[CapitalDelta]\)\/\[CapitalDelta], 
        q1 \[Rule] 1\/2\ \((\(-c4\) - c6 - s)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) - c6 + s)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\[CapitalDelta], 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\[CapitalDelta], 
        a \[Rule] ArcCos[\(-\(\@\(1 + \(c4 - c6\)\/s\)\/\@2\)\)]}, {
        q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \[CapitalDelta]\)\/\[CapitalDelta], 
        q1 \[Rule] 1\/2\ \((\(-c4\) - c6 - s)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) - c6 + s)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\[CapitalDelta], 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\[CapitalDelta], 
        a \[Rule] \(-ArcCos[\@\(1 + \(c4 - c6\)\/s\)\/\@2]\)}, {
        q0 \[Rule] 
          \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
              c1\ \[CapitalDelta]\)\/\[CapitalDelta], 
        q1 \[Rule] 1\/2\ \((\(-c4\) - c6 - s)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) - c6 + s)\), 
        x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\[CapitalDelta], 
        y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\[CapitalDelta], 
        a \[Rule] ArcCos[\@\(1 + \(c4 - c6\)\/s\)\/\@2]}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Map[
      Sin, {ArcCos[\@\(1 + \(c4 - c6\)\/s\)\/\@2], 
        \(-ArcCos[\@\(1 + \(c4 - c6\)\/s\)\/\@2]\), 
        ArcCos[\(-\(\@\(1 + \(c4 - c6\)\/s\)\/\@2\)\)], 
        \(-ArcCos[\(-\(\@\(1 + \(c4 - c6\)\/s\)\/\@2\)\)]\)}]\)], "Input"],

Cell[BoxData[
    \({\@\(1 + 1\/2\ \((\(-1\) - \(c4 - c6\)\/s)\)\), 
      \(-\@\(1 + 1\/2\ \((\(-1\) - \(c4 - c6\)\/s)\)\)\), 
      \@\(1 + 1\/2\ \((\(-1\) - \(c4 - c6\)\/s)\)\), 
      \(-\@\(1 + 1\/2\ \((\(-1\) - \(c4 - c6\)\/s)\)\)\)}\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "The restriction Sin[a] \[GreaterEqual] 0 left only 2 solutions (with \
angles ",
  Cell[BoxData[
      \(TraditionalForm
      \`a\_0 = ArcCos[
          \@\(1\/2 + \(c4 - c6\)\/\(2 \@\( c5\^2 + \((c4 - c6)\)\^2\)\)\)]
          \)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`a\_1 = \[Pi] - a\_0\)]],
  " ):"
}], "Text"],

Cell[BoxData[
    \(sol2
       := {{q0 \[Rule] 
            \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
                c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
          q1 \[Rule] 
            1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          q2 \[Rule] 
            1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
          y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
          a \[Rule] 
            ArcCos[\(-
                \(\@\(1 + \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2
                      \)\)]}, {
          q0 \[Rule] 
            \(c3\^2\ c4 - c2\ c3\ c5 + c2\^2\ c6 + 
                c1\ \((c5\^2 - 4\ c4\ c6)\)\)\/\(c5\^2 - 4\ c4\ c6\), 
          q1 \[Rule] 
            1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          q2 \[Rule] 
            1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
          x0 \[Rule] \(\(-c3\)\ c5 + 2\ c2\ c6\)\/\(c5\^2 - 4\ c4\ c6\), 
          y0 \[Rule] \(2\ c3\ c4 - c2\ c5\)\/\(c5\^2 - 4\ c4\ c6\), 
          a \[Rule] 
            ArcCos[\@\(1 + 
                    \(c4 - c6\)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\/\@2]}}\)], 
  "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \({q0 - q2\ \((\(-y0\)\ Cos[a] + x0\ Sin[a])\)\^2 - 
          q1\ \((\(-x0\)\ Cos[a] - y0\ Sin[a])\)\^2, 
        2\ q1\ x0\ Cos[a]\^2 + 2\ q1\ y0\ Cos[a]\ Sin[a] - 
          2\ q2\ y0\ Cos[a]\ Sin[a] + 2\ q2\ x0\ Sin[a]\^2, 
        2\ q2\ y0\ Cos[a]\^2 + 2\ q1\ x0\ Cos[a]\ Sin[a] - 
          2\ q2\ x0\ Cos[a]\ Sin[a] + 2\ q1\ y0\ Sin[a]\^2, 
        \(-q1\)\ Cos[a]\^2 - q2\ Sin[a]\^2, 
        \(-2\)\ q1\ Cos[a]\ Sin[a] + 2\ q2\ Cos[a]\ Sin[a], 
        \(-q2\)\ Cos[a]\^2 - q1\ Sin[a]\^2} // FortranForm\)], "Input"],

Cell["\<\
        List(q0 - q2*(-(y0*Cos(a)) + x0*Sin(a))**2 - 
     -   q1*(-(x0*Cos(a)) - y0*Sin(a))**2,
     -  2*q1*x0*Cos(a)**2 + 2*q1*y0*Cos(a)*Sin(a) - 
     -   2*q2*y0*Cos(a)*Sin(a) + 2*q2*x0*Sin(a)**2,
     -  2*q2*y0*Cos(a)**2 + 2*q1*x0*Cos(a)*Sin(a) - 
     -   2*q2*x0*Cos(a)*Sin(a) + 2*q1*y0*Sin(a)**2,
     -  -(q1*Cos(a)**2) - q2*Sin(a)**2,
     -  -2*q1*Cos(a)*Sin(a) + 2*q2*Cos(a)*Sin(a),
     -  -(q2*Cos(a)**2) - q1*Sin(a)**2)\
\>", "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(c5 == \(-2\)\ q1\ Cos[a]\ Sin[a] + 2\ q2\ Cos[a]\ Sin[a] /. {
        q1 \[Rule] 1\/2\ \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        q2 \[Rule] 1\/2\ \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\), 
        Sin[a] \[Rule] 
          \@\(1\/2 - \(c4 - c6\)\/\(2 \@\( c5\^2 + \((c4 - c6)\)\^2\)\)\)}\)],
   "Input"],

Cell[BoxData[
    \(c5 == 
      \(-\@\(1\/2 - \(c4 - c6\)\/\(2\ \@\(c5\^2 + \((c4 - c6)\)\^2\)\)\)\)\ 
          \((\(-c4\) - \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\)\ Cos[a] + 
        \@\(1\/2 - \(c4 - c6\)\/\(2\ \@\(c5\^2 + \((c4 - c6)\)\^2\)\)\)\ 
          \((\(-c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) - c6)\)\ Cos[a]\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Solve[
      c5 == \@2\ \@\(c5\^2 + \((c4 - c6)\)\^2\)\ 
          \@\(\(\( - c4\) + c6 + 
                  \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\)\)\/\@\(c4\^2 + 
                    c5\^2 - 2\ c4\ c6 + c6\^2\)\)\ Cos[a], \ Cos[a]]\)], 
  "Input"],

Cell[BoxData[
    \({{Cos[a] \[Rule] 
          c5\/\(\@2\ \@\(c5\^2 + \((c4 - c6)\)\^2\)\ 
              \@\(\(\( - c4\) + c6 + 
                      \@\(c4\^2 + c5\^2 - 2\ c4\ c6 + c6\^2\)\)\/\@\(c4\^2 + 
                        c5\^2 - 2\ c4\ c6 + c6\^2\)\)\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({Cos[a] \[Rule] 
          c5\/\(\@2\ \@\(c5\^2 + \((c4 - c6)\)\^2\)\ 
              \@\(\(\( - c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) + c6
                      \)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\)} /. 
      1\/\(Sqrt[a_]\ Sqrt[b_]\) \[Rule] 1\/Sqrt[a\ b]\)], "Input"],

Cell[BoxData[
    \({Cos[a] \[Rule] 
        c5\/\(\@2\ \@\(c5\^2 + \((c4 - c6)\)\^2\)\ 
            \@\(\(\( - c4\) + \@\(c5\^2 + \((c4 - c6)\)\^2\) + c6
                    \)\/\@\(c5\^2 + \((c4 - c6)\)\^2\)\)\)}\)], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"X 3.0",
ScreenRectangle->{{0, 1600}, {0, 1200}},
WindowSize->{755, 634},
WindowMargins->{{150, Automatic}, {Automatic, 115}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1731, 51, 65, 0, 104, "Title"],
Cell[1799, 53, 40, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[1864, 57, 84, 1, 31, "Input"],
Cell[1951, 60, 85, 1, 31, "Output"]
}, Closed]],
Cell[2051, 64, 62, 3, 47, "Text"],
Cell[2116, 69, 63, 1, 31, "Input"],
Cell[2182, 72, 22, 0, 32, "Text"],
Cell[2207, 74, 148, 2, 29, "Input"],

Cell[CellGroupData[{
Cell[2380, 80, 193, 3, 50, "Input"],
Cell[2576, 85, 161, 2, 31, "Output"]
}, Open  ]],
Cell[2752, 90, 183, 3, 49, "Input"],
Cell[2938, 95, 101, 2, 31, "Input"],
Cell[3042, 99, 116, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[3183, 106, 206, 3, 69, "Input"],
Cell[3392, 111, 514, 9, 119, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3943, 125, 631, 11, 149, "Input"],
Cell[4577, 138, 154, 3, 44, "Message"],
Cell[4734, 143, 123556, 2115, 27185, "Output"]
}, Closed]],
Cell[128305, 2261, 4683, 87, 1295, "Input"],
Cell[132991, 2350, 219, 3, 50, "Text"],
Cell[133213, 2355, 2541, 53, 650, "Input"],
Cell[135757, 2410, 192, 4, 32, "Text"],

Cell[CellGroupData[{
Cell[135974, 2418, 250, 5, 92, "Input"],
Cell[136227, 2425, 1701, 32, 486, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[137965, 2462, 261, 5, 158, "Input"],
Cell[138229, 2469, 253, 4, 104, "Output"]
}, Open  ]],
Cell[138497, 2476, 350, 12, 49, "Text"],
Cell[138850, 2490, 1270, 27, 326, "Input"],

Cell[CellGroupData[{
Cell[140145, 2521, 544, 9, 130, "Input"],
Cell[140692, 2532, 462, 10, 179, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[141191, 2547, 354, 6, 131, "Input"],
Cell[141548, 2555, 337, 6, 136, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[141922, 2566, 269, 6, 106, "Input"],
Cell[142194, 2574, 279, 5, 89, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[142510, 2584, 291, 5, 122, "Input"],
Cell[142804, 2591, 228, 4, 89, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

